<?php

# Exclude the backend from redirecting
if (strlen($contenido) == 0) {
    
    if ((class_exists('Contenido_UrlBuilder_MR')) && ($cfg['url_builder']['name'] == 'MR')) {
        
        # Redirect to the preferred language using SEO-URL
        # Get all active languages with their codes from the database
        $aCodes = array();
        $sql = 'SELECT l.name, p.value
                FROM ' . $cfg['tab']['lang'] . ' l INNER JOIN ' . $cfg['tab']['properties'] . ' p ON l.idlang = p.itemid
                WHERE ((l.active=1)
                   AND (p.idclient=' . $client . ')
                   AND (p.itemtype="idlang")
                   AND (p.type="language")
                   AND (p.name="code"))
                ORDER BY l.idlang';
        $db->query($sql);
        while ($db->next_record()) {
            $aCodes[] = $db->f('value');
        }

        # Redirect visitors according to their preferred language
        $bOK = false;
        if (substr($_SERVER['REQUEST_URI'], 3, 1) == '/') {
            
            # The request uri starts with a speech code like '/de/'
            $sLang = substr($_SERVER['REQUEST_URI'], 1, 2);
            if (in_array($sLang, $aCodes)) {
                
                # Do nothing, a language is already selected
                $bOK = true;
            }
            else {
                $_SERVER['REQUEST_URI'] = substr($_SERVER['REQUEST_URI'], 3);
            }
        }
        if (!$bOK) {
            $aPreferred = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
            foreach ($aPreferred as $sPossible) {
                if (in_array(substr($sPossible, 0, 2), $aCodes)) {
                    header('Location: /' . substr($sPossible, 0, 2) . $_SERVER['REQUEST_URI']);
                    die();
                }
            }
            
            # If no language fits, use the client's first (default) language
            header('Location: /' . $aCodes[0] . $_SERVER['REQUEST_URI']);
            die();
        }
    }
    else {
        
        # Redirect to the preferred language using 'changelang' parameter
        # Get all active languages with their IDs from the database
        $aLangs = array();
        $aCodes = array();
        $sql = 'SELECT l.idlang, p.value
                FROM ' . $cfg['tab']['lang'] . ' l INNER JOIN ' . $cfg['tab']['properties'] . ' p ON l.idlang = p.itemid INNER JOIN ' . $cfg['tab']['clients_lang'] . ' cl ON l.idlang = cl.idlang
                WHERE ((l.active=1)
                   AND (p.idclient=' . $client . ')
                   AND (p.itemtype="idlang")
                   AND (p.type="language")
                   AND (p.name="code")
                   AND (cl.idclient=' . $client . '))
                ORDER BY l.idlang';
        $db->query($sql);
        while ($db->next_record()) {
            $aLangs[] = $db->f('idlang');
            $aCodes[] = $db->f('value');
        }

        # Redirect visitors according to their preferred language
        $bOK = false;
        if ((isset($_GET['changelang'])) || (isset($_GET['lang']))) {
            
            # The request uri has a language selected, either with 'lang=', or with 'changelang='
            if (isset($_GET['changelang'])) {
                $iLang = intval($_GET['changelang']);
                if (in_array($iLang, $aLangs)) {
                    
                    # Do nothing, a language is already selected
                    $bOK = true;
                }
                else {
                    unset($_GET['changelang']);
                }
            }
            if (isset($_GET['lang'])) {
                $iLang = intval($_GET['lang']);
                if (in_array($iLang, $aLangs)) {
                    
                    # Do nothing, a language is already selected
                    $bOK = true;
                }
                else {
                    unset($_GET['lang']);
                }
            }
        }
        if (!$bOK) {
            $aPreferred = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
            foreach ($aPreferred as $sPossible) {
                if (in_array(substr($sPossible, 0, 2), $aCodes)) {
                    header('Location: ' . $_SERVER['REQUEST_URI'] . ((strpos($_SERVER['REQUEST_URI'], '?') === false) ? '?' : '&') . 'changelang=' . $aLangs[array_search(substr($sPossible, 0, 2), $aCodes)]);
                    die();
                }
            }
            
            # If no language fits, use the client's first (default) language
            header('Location: ' . $_SERVER['REQUEST_URI'] . ((strpos($_SERVER['REQUEST_URI'], '?') === false) ? '?' : '&') . 'changelang=' . $aLangs[0]);
            die();
        }
    }
}
?>